> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Retrieve all Expected Switches

GET https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/expected-switch

Retrieve all Expected Switches.

Org must have an Infrastructure Provider entity. User must have `FORGE_PROVIDER_ADMIN` or `FORGE_PROVIDER_VIEWER` role.

Alternatively, Tenant Admins with `TargetedInstanceCreation` capability can also retrieve Expected Switches if they have an account with the Site's Infrastructure Provider (siteId query parameter is required for Tenants).

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/expected-switch/get-all-expected-switch

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/expected-switch:
    get:
      operationId: get-all-expected-switch
      summary: Retrieve all Expected Switches
      description: >-
        Retrieve all Expected Switches.


        Org must have an Infrastructure Provider entity. User must have
        `FORGE_PROVIDER_ADMIN` or `FORGE_PROVIDER_VIEWER` role.


        Alternatively, Tenant Admins with `TargetedInstanceCreation` capability
        can also retrieve Expected Switches if they have an account with the
        Site's Infrastructure Provider (siteId query parameter is required for
        Tenants).
      tags:
        - subpackage_expectedSwitch
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: siteId
          in: query
          description: ID of the Site to filter Expected Switches by
          required: false
          schema:
            type: string
            format: uuid
        - name: includeRelation
          in: query
          description: Related entity to expand
          required: false
          schema:
            $ref: >-
              #/components/schemas/V2OrgOrgCarbideExpectedSwitchGetParametersIncludeRelation
        - name: pageNumber
          in: query
          description: Page number for pagination query
          required: false
          schema:
            type: integer
            default: 1
        - name: pageSize
          in: query
          description: Page size for pagination query
          required: false
          schema:
            type: integer
        - name: orderBy
          in: query
          description: Ordering for pagination query
          required: false
          schema:
            $ref: >-
              #/components/schemas/V2OrgOrgCarbideExpectedSwitchGetParametersOrderBy
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ExpectedSwitch'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    V2OrgOrgCarbideExpectedSwitchGetParametersIncludeRelation:
      type: string
      enum:
        - Site
      title: V2OrgOrgCarbideExpectedSwitchGetParametersIncludeRelation
    V2OrgOrgCarbideExpectedSwitchGetParametersOrderBy:
      type: string
      enum:
        - BMC_MAC_ADDRESS_ASC
        - BMC_MAC_ADDRESS_DESC
        - SWITCH_SERIAL_NUMBER_ASC
        - SWITCH_SERIAL_NUMBER_DESC
        - CREATED_ASC
        - CREATED_DESC
        - UPDATED_ASC
        - UPDATED_DESC
      title: V2OrgOrgCarbideExpectedSwitchGetParametersOrderBy
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    ExpectedSwitch:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the Expected Switch
        siteId:
          type: string
          format: uuid
          description: ID of the site the Expected Switch belongs to
        bmcMacAddress:
          type: string
          description: >-
            MAC address of the Expected Switch's BMC (Baseboard Management
            Controller)
        switchSerialNumber:
          type: string
          description: Serial number of the Expected Switch
        rackId:
          type:
            - string
            - 'null'
          description: Optional rack identifier for this component
        name:
          type:
            - string
            - 'null'
          description: Display name for this component
        manufacturer:
          type:
            - string
            - 'null'
          description: Manufacturer of this component
        model:
          type:
            - string
            - 'null'
          description: Model of this component
        description:
          type:
            - string
            - 'null'
          description: Description of this component
        firmwareVersion:
          type:
            - string
            - 'null'
          description: Firmware version of this component
        slotId:
          type:
            - integer
            - 'null'
          description: Slot ID within the rack
        trayIdx:
          type:
            - integer
            - 'null'
          description: Tray index within the rack
        hostId:
          type:
            - integer
            - 'null'
          description: Host ID within the tray
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Switches
        created:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Switch was created
        updated:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Switch was last updated
      description: >-
        An Expected Switch represents a network switch that is expected to be
        discovered at a site, with hardware identifiers and metadata.


        Note: BMC and NvOS credentials (username/password) are only accepted
        during creation and updates but are not returned in responses.
      title: ExpectedSwitch
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```